<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <div class = "container mt-4">
    <h2 class = "text-center">F200 - LỊCH SỬ HỌC TẬP</h2>
    <div class = "row jumbotron p-3 m-0">
        <div class = "col-md-12">
                <div class = "row">
                    <h5>Thông tin học viên:</h5>
                </div>
                <div class = "row form-group">
                    <div class = "col-2">
                        <label>Student</label>
                    </div>
                    <div class="col-sm-3">
                      <select id="select-student" class="form-control">
              
                      </select>
                    </div>
                    <div class = "col-2">
                      <label>Subject</label>
                    </div>
                    <div class="col-sm-3">
                      <select id="select-subject" class="form-control">
            
                      </select>
                    </div>
                    <div class="col-sm-2">
                      <button class = "btn btn-success" id = "btn-filter-data">Lọc dữ liệu</button>
                    </div>
                </div>
        </div>
    </div>
    <br>
    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="student-table">
        <thead class = "text-center">
          <tr>
            <th>STT</th>
            <th>Sinh viên</th>
            <th>Môn học</th>
            <th>Điểm</th>
            <th>Ngày thi</th>
          </tr>
        </thead>
      </table>
    </div>
  </div>
  <script>
    "use strict";
    /* Mảng userObjects là mảng chứa dữ liệu user. Từng phần tử là object
    */
    var gStudents = [
      {
        id: 2, // tự tăng
        studentCode: "1356783",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        studyYear: 2015
      },
      {
        id: 3, // tự tăng
        studentCode: "1234567",
        firstname: "Tran Van",
        lastname: "Ninh",
        age: 20,
        email: "ninh@gmail.com",
        studyYear: 2019
      },
      {
        id: 4, // tự tăng
        studentCode: "1234568",
        firstname: "Nguyen Hoang",
        lastname: "Hai",
        age: 22,
        email: "hai@gmail.com",
        studyYear: 2020
      },
      {
        id: 5, // tự tăng
        studentCode: "1234569",
        firstname: "Le Duc",
        lastname: "Thanh",
        age: 23,
        email: "thanh@gmail.com",
        studyYear: 2021
      },
      {
        id: 6, // tự tăng
        studentCode: "1234579",
        firstname: "Dinh Van",
        lastname: "An",
        age: 21,
        email: "an@gmail.com",
        studyYear: 2020
      }
    ];

    var gSubjects = [
      {
        id: 5, // tự tăng
        subjectCode: "MATH101",
        subjectName: "Toán cao cấp 1"
      },
      {
        id: 6, // tự tăng
        subjectCode: "PHYS101",
        subjectName: "Vật lý đại cương 1"
      },
      {
        id: 7, // tự tăng
        subjectCode: "CHEM101",
        subjectName: "Hóa đại cương 1"
      },
      {
        id: 8, // tự tăng
        subjectCode: "BIOL101",
        subjectName: "Sinh học đại cương 1"
      },
      {
        id: 9, // tự tăng
        subjectCode: "LITE101",
        subjectName: "Văn học đương đại 1"
      }
      // điền thêm 04 môn học nữa
    ];

    var gGrades = [
      {
        id: 2, // tự tăng
        studentId: 2,
        subjectId: 5,
        grade: 8,
        examDate: "13/04/2021"
      },
      {
        id: 3, // tự tăng
        studentId: 3,
        subjectId: 6,
        grade: 8,
        examDate: "14/05/2021"
      },
      {
        id: 4, // tự tăng
        studentId: 5,
        subjectId: 7,
        grade: 8,
        examDate: "19/06/2021"
      },
      {
        id: 5, // tự tăng
        studentId: 6,
        subjectId: 7,
        grade: 9,
        examDate: "20/07/2021"
      },
      {
        id: 6, // tự tăng
        studentId: 4,
        subjectId: 8,
        grade: 9,
        examDate: "30/08/2021"
      },
      {
        id: 7, // tự tăng
        studentId: 6,
        subjectId: 9,
        grade: 9,
        examDate: "30/09/2021"
      },
      {
        id: 8, // tự tăng
        studentId: 4,
        subjectId: 5,
        grade: 7,
        examDate: "15/10/2021"
      },
      {
        id: 9, // tự tăng
        studentId: 5,
        subjectId: 5,
        grade: 6,
        examDate: "15/02/2021"
      },
      {
        id: 10, // tự tăng
        studentId: 3,
        subjectId: 9,
        grade: 7,
        examDate: "15/01/2021"
      },
      {
        id: 11, // tự tăng
        studentId: 4,
        subjectId: 7,
        grade: 7,
        examDate: "28/02/2021"
      }
      // điền thêm 9 kết quả thi nữa
    ];
    console.log("Mảng Sinh viên: ");
    console.log(gStudents);
    console.log("Mảng Môn học: ");
    console.log(gSubjects);
    console.log("Mảng Điểm: ")
    console.log(gGrades);
    const gARRAY_COL_NAME = ["stt", "student", "subject", "grade", "date"];
    const gCOL_STT = 0;
    const gCOL_STUDENT = 1;
    const gCOL_SUBJECT = 2;
    const gCOL_GRADE = 3;
    const gCOL_DATE = 4;
    var gSTT = 0;
    var gObjectData = [];
    $('#student-table').DataTable({        
          columns: [  
            { data: gARRAY_COL_NAME[gCOL_STT] },
            { data: gARRAY_COL_NAME[gCOL_STUDENT] },
            { data: gARRAY_COL_NAME[gCOL_SUBJECT] },
            { data: gARRAY_COL_NAME[gCOL_GRADE] },
            { data: gARRAY_COL_NAME[gCOL_DATE] },
          ],
          columnDefs: [
              { 
                targets:gCOL_STT, 
                render: function(){
                  gSTT++;
                  return gSTT;
                }
              },
              { 
                targets:gCOL_SUBJECT, 
                className: "text-center"
              },
              { 
                targets:gCOL_GRADE, 
                className: "text-center"
              },
              { 
                targets:gCOL_DATE, 
                className: "text-center"
              },
              
          ],
          autoWidth: false
        });
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function(){
    onPageLoading();
    
      $("#btn-filter-data").on("click",function(){
        onBtnFilterClick();
      })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
      function onPageLoading(){
        var bI = 0;
        while (bI < gGrades.length) {
          var bObject = {'id': bI, 'student': getStudentInfoFromId(gGrades[bI].studentId), 'subject': getSubjectInfoFromId(gGrades[bI].subjectId), 'grade': gGrades[bI].grade, 'date': gGrades[bI].examDate};
          gObjectData.push(bObject);  
          bI++;  
          }
        console.log("object");
        console.log(gObjectData);
        loadDataToUserTable(gObjectData);
        loadDataToSelectStudent(gStudents);
        loadDataToSelectSubject(gSubjects);
      }
      function loadDataToUserTable(paramObjectUsers){
        console.log("Hàm load table");
        var vTable = $("#student-table").DataTable();
        vTable.clear();
        vTable.rows.add(paramObjectUsers);
        vTable.draw();
      }
      function loadDataToSelectStudent(paramStudentObj){
        "use strict";
        // Thêm option mặc định
        $('#select-student').append($('<option>', {
            value: "0",
            text: "=== Chọn Sinh viên ==="
        }));
        // Thêm các option từ dữ liệu
        for(var bI = 0; bI < paramStudentObj.length; bI++){
          $('#select-student').append($('<option>', {
            value: paramStudentObj[bI].studentCode,
            text: paramStudentObj[bI].firstname + " "+ paramStudentObj[bI].lastname
          }));
        }      
      }
      function loadDataToSelectSubject(paramSubjectObj){
        "use strict";
        // Thêm option mặc định
        $('#select-subject').append($('<option>', {
            value: "0",
            text: "=== Chọn Môn học ==="
        }));
        // Thêm các option từ dữ liệu
        for(var bI = 0; bI < paramSubjectObj.length; bI++){
          $('#select-subject').append($('<option>', {
            value: paramSubjectObj[bI].subjectCode,
            text: paramSubjectObj[bI].subjectName
          }));
        }      
      }
      function getStudentInfoFromId(paramId){
        "use strict";
        var vStudentInfo = "";
        for (var bI= 0; bI< gStudents.length; bI++){
            if (gStudents[bI].id == paramId){
              vStudentInfo = gStudents[bI].firstname + " " + gStudents[bI].lastname;
            }
        }
        return vStudentInfo;
      }
      function getSubjectInfoFromId(paramId){
        "use strict";
        var vSubjectInfo = "";
        for (var bI= 0; bI< gSubjects.length; bI++){
            if (gSubjects[bI].id == paramId){
              vSubjectInfo = gSubjects[bI].subjectName;
            }
        }
        return vSubjectInfo;
    } 
    // Hàm xử lý khi click nút filter
    function onBtnFilterClick(){
        "use strict";
        //debugger;
        console.log("Filter");
        var vObjectFilter = {
          student: "",
          subject: ""
        }

        // Bước 1: Thu thập dữ liệu từ select
        getDataFromSelect(vObjectFilter);
        console.log(vObjectFilter);
        // Bước 2: Kiểm tra dữ liệu - bỏ qua

        // Bước 3: Lọc dữ liệu
        var vResultFilter = filterData(vObjectFilter);
        console.log(vResultFilter);
        // Bước 4: Hiển thị dữ liệu lên Datatable
        loadDataToUserTable(vResultFilter);
      }
      function getDataFromSelect(paramObjectFilter){
        "use strict";
        paramObjectFilter.student = $("#select-student option:selected").text();
        paramObjectFilter.subject = $("#select-subject option:selected").text();
      }
      function filterData(paramObjectFilter){
      "use strict";
      
      var vFilter = gObjectData.filter(function(item){
        if (paramObjectFilter.student != 0 && paramObjectFilter.subject != 0){
          return (item.student == paramObjectFilter.student && item.subject == paramObjectFilter.subject)
        }
        if (paramObjectFilter.student === 0 && paramObjectFilter.subject != 0) {
          return (item.student == paramObjectFilter.student || paramObjectFilter.student == 0 || item.subject == paramObjectFilter.subject || paramObjectFilter.subject == 0);
        } 
        if (paramObjectFilter.student != 0 && paramObjectFilter.subject === 0) {
          return (item.student == paramObjectFilter.student || paramObjectFilter.student == 0 || item.subject == paramObjectFilter.subject || paramObjectFilter.subject == 0);
        } 
      })
      return vFilter;
    }
  })
  </script>
</body>

</html>